# openapi-client
The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientExperimentalCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https:////.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https:////.git`)

Then import the package:
```python
import openapi_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import openapi_client
from openapi_client.rest import ApiException
from pprint import pprint

configuration = openapi_client.Configuration()
# Configure API key authorization: instanceId
configuration.api_key['instanceId'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['instanceId'] = 'Bearer'
configuration = openapi_client.Configuration()
# Configure API key authorization: token
configuration.api_key['token'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['token'] = 'Bearer'

# Defining host is optional and default to https://api.chat-api.com
configuration.host = "https://api.chat-api.com"
# Create an instance of the API class
api_instance = openapi_client.1InstanceApi(openapi_client.ApiClient(configuration))

try:
    # Updates the QR code after its expired
    api_response = api_instance.expiry()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling 1InstanceApi->expiry: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.chat-api.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*1InstanceApi* | [**expiry**](docs/1InstanceApi.md#expiry) | **POST** /expiry | Updates the QR code after its expired
*1InstanceApi* | [**get_qr_code**](docs/1InstanceApi.md#get_qr_code) | **GET** /qr_code | Direct link to QR-code in the form of an image, not base64.
*1InstanceApi* | [**get_settings**](docs/1InstanceApi.md#get_settings) | **GET** /settings | Get settings
*1InstanceApi* | [**get_status**](docs/1InstanceApi.md#get_status) | **GET** /status | Get the account status and QR code for authorization.
*1InstanceApi* | [**logout**](docs/1InstanceApi.md#logout) | **POST** /logout | Logout from WhatsApp Web to get new QR code.
*1InstanceApi* | [**reboot**](docs/1InstanceApi.md#reboot) | **POST** /reboot | Reboot your whatsapp instance.
*1InstanceApi* | [**retry**](docs/1InstanceApi.md#retry) | **POST** /retry | Repeat the manual synchronization attempt with the device
*1InstanceApi* | [**set_settings**](docs/1InstanceApi.md#set_settings) | **POST** /settings | Set settings
*1InstanceApi* | [**takeover**](docs/1InstanceApi.md#takeover) | **POST** /takeover | Returns the active session if the device has connected another instance of Web WhatsApp
*2MessagesApi* | [**forward_message**](docs/2MessagesApi.md#forward_message) | **POST** /forwardMessage | Forwarding messages to a new or existing chat.
*2MessagesApi* | [**get_messages**](docs/2MessagesApi.md#get_messages) | **GET** /messages | Get a list of messages.
*2MessagesApi* | [**send_contact**](docs/2MessagesApi.md#send_contact) | **POST** /sendContact | Sending a contact or contact list to a new or existing chat.
*2MessagesApi* | [**send_file**](docs/2MessagesApi.md#send_file) | **POST** /sendFile | Send a file to a new or existing chat.
*2MessagesApi* | [**send_link**](docs/2MessagesApi.md#send_link) | **POST** /sendLink | Send text with link and link&#39;s preview to a new or existing chat.
*2MessagesApi* | [**send_location**](docs/2MessagesApi.md#send_location) | **POST** /sendLocation | Sending a location to a new or existing chat.
*2MessagesApi* | [**send_message**](docs/2MessagesApi.md#send_message) | **POST** /sendMessage | Send a message to a new or existing chat.
*2MessagesApi* | [**send_ptt**](docs/2MessagesApi.md#send_ptt) | **POST** /sendPTT | Send a ptt-audio to a new or existing chat.
*2MessagesApi* | [**send_v_card**](docs/2MessagesApi.md#send_v_card) | **POST** /sendVCard | Sending a vcard to a new or existing chat.
*3ChatsApi* | [**add_group_participant**](docs/3ChatsApi.md#add_group_participant) | **POST** /addGroupParticipant | Adding participant to a group
*3ChatsApi* | [**demote_group_participant**](docs/3ChatsApi.md#demote_group_participant) | **POST** /demoteGroupParticipant | Demote group participant
*3ChatsApi* | [**get_chats**](docs/3ChatsApi.md#get_chats) | **GET** /dialogs | Get the chat list.
*3ChatsApi* | [**group**](docs/3ChatsApi.md#group) | **POST** /group | Creates a group and sends the message to the created group.
*3ChatsApi* | [**promote_group_participant**](docs/3ChatsApi.md#promote_group_participant) | **POST** /promoteGroupParticipant | Make participant in the group an administrator
*3ChatsApi* | [**read_chat**](docs/3ChatsApi.md#read_chat) | **POST** /readChat | Open chat for reading messages
*3ChatsApi* | [**remove_group_participant**](docs/3ChatsApi.md#remove_group_participant) | **POST** /removeGroupParticipant | Remove participant from a group
*4WebhooksApi* | [**set_webhook**](docs/4WebhooksApi.md#set_webhook) | **POST** /webhook | Sets the URL for receiving webhook
*5QueuesApi* | [**clear_actions_queue**](docs/5QueuesApi.md#clear_actions_queue) | **POST** /clearActionsQueue | Clear outbound actions queue.
*5QueuesApi* | [**clear_messages_queue**](docs/5QueuesApi.md#clear_messages_queue) | **POST** /clearMessagesQueue | Clear outbound messages queue.
*5QueuesApi* | [**show_actions_queue**](docs/5QueuesApi.md#show_actions_queue) | **GET** /showActionsQueue | Get outbound messages queue.
*5QueuesApi* | [**show_messages_queue**](docs/5QueuesApi.md#show_messages_queue) | **GET** /showMessagesQueue | Get outbound messages queue.
*6BanApi* | [**ban_test**](docs/6BanApi.md#ban_test) | **POST** /banTest | Test ban settings
*6BanApi* | [**get_ban_settings**](docs/6BanApi.md#get_ban_settings) | **GET** /banSettings | Get settings
*6BanApi* | [**set_ban_settings**](docs/6BanApi.md#set_ban_settings) | **POST** /banSettings | Set settings
*7TestingApi* | [**instance_statuses**](docs/7TestingApi.md#instance_statuses) | **GET** /instanceStatuses | Returns instance status changes history.
*7TestingApi* | [**webhook_statuses**](docs/7TestingApi.md#webhook_statuses) | **GET** /webhookStatus | Returns webhook status for message.


## Documentation For Models

 - [Ack](docs/Ack.md)
 - [BanSettings](docs/BanSettings.md)
 - [BanTestAction](docs/BanTestAction.md)
 - [BanTestStatus](docs/BanTestStatus.md)
 - [Chat](docs/Chat.md)
 - [ChatIdProp](docs/ChatIdProp.md)
 - [ChatUpdate](docs/ChatUpdate.md)
 - [Chats](docs/Chats.md)
 - [ClearActionsQueueStatus](docs/ClearActionsQueueStatus.md)
 - [ClearMessagesQueueStatus](docs/ClearMessagesQueueStatus.md)
 - [CreateGroupAction](docs/CreateGroupAction.md)
 - [CreateGroupStatus](docs/CreateGroupStatus.md)
 - [ForwardMessageRequest](docs/ForwardMessageRequest.md)
 - [GroupParticipantAction](docs/GroupParticipantAction.md)
 - [GroupParticipantStatus](docs/GroupParticipantStatus.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2005Update](docs/InlineResponse2005Update.md)
 - [InlineResponse401](docs/InlineResponse401.md)
 - [InstanceStatus](docs/InstanceStatus.md)
 - [InstanceStatusAction](docs/InstanceStatusAction.md)
 - [InstanceStatusLink](docs/InstanceStatusLink.md)
 - [InstanceStatusStatusData](docs/InstanceStatusStatusData.md)
 - [InstanceStatusStatusDataActions](docs/InstanceStatusStatusDataActions.md)
 - [Message](docs/Message.md)
 - [Messages](docs/Messages.md)
 - [OutboundAction](docs/OutboundAction.md)
 - [OutboundActions](docs/OutboundActions.md)
 - [OutboundMessage](docs/OutboundMessage.md)
 - [OutboundMessages](docs/OutboundMessages.md)
 - [PhoneProp](docs/PhoneProp.md)
 - [ReadChatAction](docs/ReadChatAction.md)
 - [ReadChatStatus](docs/ReadChatStatus.md)
 - [SendContactRequest](docs/SendContactRequest.md)
 - [SendFileRequest](docs/SendFileRequest.md)
 - [SendLinkRequest](docs/SendLinkRequest.md)
 - [SendLocationRequest](docs/SendLocationRequest.md)
 - [SendMessageRequest](docs/SendMessageRequest.md)
 - [SendMessageStatus](docs/SendMessageStatus.md)
 - [SendPTTRequest](docs/SendPTTRequest.md)
 - [SendVCardRequest](docs/SendVCardRequest.md)
 - [SetWebhookStatus](docs/SetWebhookStatus.md)
 - [Settings](docs/Settings.md)
 - [Status](docs/Status.md)
 - [Statuses](docs/Statuses.md)
 - [WebhookStatus](docs/WebhookStatus.md)
 - [WebhookUrl](docs/WebhookUrl.md)


## Documentation For Authorization


## instanceId

- **Type**: API key
- **API key parameter name**: instanceId
- **Location**: URL query string


## token

- **Type**: API key
- **API key parameter name**: token
- **Location**: URL query string


## Author

sale@chat-api.com


