# coding: utf-8

"""
    Chat API SDK

    The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: sale@chat-api.com
    Generated by: https://openapi-generator.tech
"""


import pprint  # noqa: F401
import re  # noqa: F401

import six  # noqa: F401

from openapi_client.exceptions import ApiValueError  # noqa: F401
from openapi_client.model_utils import (  # noqa: F401
    ModelNormal,
    ModelSimple,
    check_allowed_values,
    check_validations
)


class Ack(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      openapi_types (dict): The key is attribute name
          and the value is attribute type.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
    """

    allowed_values = {
        ('status',): {
            'DELIVERED': "delivered",
            'VIEWED': "viewed"
        },
    }

    attribute_map = {
        'id': 'id',  # noqa: E501
        'queue_number': 'queueNumber',  # noqa: E501
        'chat_id': 'chatId',  # noqa: E501
        'status': 'status'  # noqa: E501
    }

    openapi_types = {
        'id': 'str',
        'queue_number': 'int',
        'chat_id': 'str',
        'status': 'str'
    }

    validations = {
    }

    def __init__(self, id=None, queue_number=None, chat_id=None, status=None):  # noqa: E501
        """Ack - a model defined in OpenAPI"""  # noqa: E501

        self._id = None
        self._queue_number = None
        self._chat_id = None
        self._status = None
        self.discriminator = None

        if id is not None:
            self.id = (
                id
            )
        if queue_number is not None:
            self.queue_number = (
                queue_number
            )
        if chat_id is not None:
            self.chat_id = (
                chat_id
            )
        if status is not None:
            self.status = (
                status
            )

    @property
    def id(self):
        """Gets the id of this Ack.  # noqa: E501

        unique id  # noqa: E501

        :return: The id of this Ack.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):  # noqa: E501
        """Sets the id of this Ack.

        unique id  # noqa: E501

        :param id: The id of this Ack.  # noqa: E501
        :type: str
        """

        self._id = (
            id
        )

    @property
    def queue_number(self):
        """Gets the queue_number of this Ack.  # noqa: E501

        message id in queue  # noqa: E501

        :return: The queue_number of this Ack.  # noqa: E501
        :rtype: int
        """
        return self._queue_number

    @queue_number.setter
    def queue_number(self, queue_number):  # noqa: E501
        """Sets the queue_number of this Ack.

        message id in queue  # noqa: E501

        :param queue_number: The queue_number of this Ack.  # noqa: E501
        :type: int
        """

        self._queue_number = (
            queue_number
        )

    @property
    def chat_id(self):
        """Gets the chat_id of this Ack.  # noqa: E501

        chat ID  # noqa: E501

        :return: The chat_id of this Ack.  # noqa: E501
        :rtype: str
        """
        return self._chat_id

    @chat_id.setter
    def chat_id(self, chat_id):  # noqa: E501
        """Sets the chat_id of this Ack.

        chat ID  # noqa: E501

        :param chat_id: The chat_id of this Ack.  # noqa: E501
        :type: str
        """

        self._chat_id = (
            chat_id
        )

    @property
    def status(self):
        """Gets the status of this Ack.  # noqa: E501

        type of the message status  # noqa: E501

        :return: The status of this Ack.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):  # noqa: E501
        """Sets the status of this Ack.

        type of the message status  # noqa: E501

        :param status: The status of this Ack.  # noqa: E501
        :type: str
        """
        check_allowed_values(
            self.allowed_values,
            ('status',),
            status,
            self.validations
        )

        self._status = (
            status
        )

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Ack):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
