# coding: utf-8

"""
    Chat API SDK

    The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: sale@chat-api.com
    Generated by: https://openapi-generator.tech
"""


import pprint  # noqa: F401
import re  # noqa: F401

import six  # noqa: F401

from openapi_client.exceptions import ApiValueError  # noqa: F401
from openapi_client.model_utils import (  # noqa: F401
    ModelNormal,
    ModelSimple,
    check_allowed_values,
    check_validations
)


class CreateGroupStatus(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      openapi_types (dict): The key is attribute name
          and the value is attribute type.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
    """

    allowed_values = {
    }

    attribute_map = {
        'created': 'created',  # noqa: E501
        'message': 'message',  # noqa: E501
        'chat_id': 'chatId',  # noqa: E501
        'group_invite_link': 'groupInviteLink'  # noqa: E501
    }

    openapi_types = {
        'created': 'bool',
        'message': 'str',
        'chat_id': 'str',
        'group_invite_link': 'str'
    }

    validations = {
    }

    def __init__(self, created=None, message=None, chat_id=None, group_invite_link=None):  # noqa: E501
        """CreateGroupStatus - a model defined in OpenAPI"""  # noqa: E501

        self._created = None
        self._message = None
        self._chat_id = None
        self._group_invite_link = None
        self.discriminator = None

        if created is not None:
            self.created = (
                created
            )
        if message is not None:
            self.message = (
                message
            )
        if chat_id is not None:
            self.chat_id = (
                chat_id
            )
        if group_invite_link is not None:
            self.group_invite_link = (
                group_invite_link
            )

    @property
    def created(self):
        """Gets the created of this CreateGroupStatus.  # noqa: E501


        :return: The created of this CreateGroupStatus.  # noqa: E501
        :rtype: bool
        """
        return self._created

    @created.setter
    def created(self, created):  # noqa: E501
        """Sets the created of this CreateGroupStatus.


        :param created: The created of this CreateGroupStatus.  # noqa: E501
        :type: bool
        """

        self._created = (
            created
        )

    @property
    def message(self):
        """Gets the message of this CreateGroupStatus.  # noqa: E501

        Group creation status  # noqa: E501

        :return: The message of this CreateGroupStatus.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):  # noqa: E501
        """Sets the message of this CreateGroupStatus.

        Group creation status  # noqa: E501

        :param message: The message of this CreateGroupStatus.  # noqa: E501
        :type: str
        """

        self._message = (
            message
        )

    @property
    def chat_id(self):
        """Gets the chat_id of this CreateGroupStatus.  # noqa: E501

        Created group id  # noqa: E501

        :return: The chat_id of this CreateGroupStatus.  # noqa: E501
        :rtype: str
        """
        return self._chat_id

    @chat_id.setter
    def chat_id(self, chat_id):  # noqa: E501
        """Sets the chat_id of this CreateGroupStatus.

        Created group id  # noqa: E501

        :param chat_id: The chat_id of this CreateGroupStatus.  # noqa: E501
        :type: str
        """

        self._chat_id = (
            chat_id
        )

    @property
    def group_invite_link(self):
        """Gets the group_invite_link of this CreateGroupStatus.  # noqa: E501

        Link invitation to the group  # noqa: E501

        :return: The group_invite_link of this CreateGroupStatus.  # noqa: E501
        :rtype: str
        """
        return self._group_invite_link

    @group_invite_link.setter
    def group_invite_link(self, group_invite_link):  # noqa: E501
        """Sets the group_invite_link of this CreateGroupStatus.

        Link invitation to the group  # noqa: E501

        :param group_invite_link: The group_invite_link of this CreateGroupStatus.  # noqa: E501
        :type: str
        """

        self._group_invite_link = (
            group_invite_link
        )

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateGroupStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
