# coding: utf-8

"""
    Chat API SDK

    The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: sale@chat-api.com
    Generated by: https://openapi-generator.tech
"""


import pprint  # noqa: F401
import re  # noqa: F401

import six  # noqa: F401

from openapi_client.exceptions import ApiValueError  # noqa: F401
from openapi_client.model_utils import (  # noqa: F401
    ModelNormal,
    ModelSimple,
    check_allowed_values,
    check_validations
)


class InstanceStatusAction(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      openapi_types (dict): The key is attribute name
          and the value is attribute type.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
    """

    allowed_values = {
        ('act',): {
            'EXPIRY': "expiry",
            'RETRY': "retry",
            'TAKEOVER': "takeover",
            'LOGOUT': "logout"
        },
    }

    attribute_map = {
        'act': 'act',  # noqa: E501
        'label': 'label'  # noqa: E501
    }

    openapi_types = {
        'act': 'str',
        'label': 'str'
    }

    validations = {
    }

    def __init__(self, act=None, label=None):  # noqa: E501
        """InstanceStatusAction - a model defined in OpenAPI"""  # noqa: E501

        self._act = None
        self._label = None
        self.discriminator = None

        if act is not None:
            self.act = (
                act
            )
        if label is not None:
            self.label = (
                label
            )

    @property
    def act(self):
        """Gets the act of this InstanceStatusAction.  # noqa: E501

        Method name  # noqa: E501

        :return: The act of this InstanceStatusAction.  # noqa: E501
        :rtype: str
        """
        return self._act

    @act.setter
    def act(self, act):  # noqa: E501
        """Sets the act of this InstanceStatusAction.

        Method name  # noqa: E501

        :param act: The act of this InstanceStatusAction.  # noqa: E501
        :type: str
        """
        check_allowed_values(
            self.allowed_values,
            ('act',),
            act,
            self.validations
        )

        self._act = (
            act
        )

    @property
    def label(self):
        """Gets the label of this InstanceStatusAction.  # noqa: E501

        Action caption for the button  # noqa: E501

        :return: The label of this InstanceStatusAction.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):  # noqa: E501
        """Sets the label of this InstanceStatusAction.

        Action caption for the button  # noqa: E501

        :param label: The label of this InstanceStatusAction.  # noqa: E501
        :type: str
        """

        self._label = (
            label
        )

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstanceStatusAction):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
